/***************
 File: setup.p
 Purpose: Installation program
 Description:
 Author(s) :Per S Digre/PSC
 Created: April 1999
 Notes:
 Modification History:
 $Header: $
 $Log:  $

This file contains sample code which may assist you in creating applications.
You may use the code as you see fit. If you modify the code or include it in another software program,
you will refrain from identifying Progress Software as the supplier of the code, or using any
Progress Software trademarks in connection with your use of the code.
THE CODE IS NOT SUPPORTED BY PROGRESS SOFTWARE AND IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
INCLUDING, WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NONINFRINGEMENT.

*******************************************/
{src/web/method/cgidefs.i}

def var cFrom as char no-undo.
def var cDest as char no-undo.
def var cIn   as char no-undo.
def var cDB   as char no-undo.
def var cData as char no-undo init " ".
def var iPos   as int  no-undo.
def var cStat1 as char no-undo.
def var cStat2 as char no-undo.
def var cStat3 as char no-undo.
def var cStat4 as char no-undo.
def stream sIn.







FUNCTION fProcess RETURNS CHARACTER(INPUT cCmd AS CHARACTER,INPUT cAvoid AS CHAR):
  {&out} "<p>" HTML-ENCODE(cCmd) "</p>".
  IF cAvoid = "" THEN cAvoid = "&&&gh~&&&".
  INPUT STREAM sIn THROUGH VALUE(cCmd).
  REPEAT:
    IMPORT STREAM sIn UNFORMATTED cIn NO-ERROR.
    IF Error-status:error THEN DO:
      {&out} "<p>Error in command.</p>" SKIP.
      RETURN "".
    END.
    IF cIn MATCHES cAvoid THEN NEXT.
    {&out} "<p>" HTML-ENCODE(cIn) "</p>".
  END.
  INPUT STREAM sIn CLOSE.
END FUNCTION.

FUNCTION fCompile RETURNS CHAR(INPUT cFile AS CHAR):
  DEF VAR object-type AS CHAR NO-UNDO.
  DEF VAR cTempFile   AS CHAR NO-UNDO.
  DEF VAR cReturn     AS CHAR NO-UNDO.
  DEF VAR i1          AS INT  NO-UNDO.

  IF cFile MATCHES "*.html" OR cFile MATCHES "*.htm" THEN DO:
    RUN webutil/e4gl-gen.p (INPUT SEARCH(cFile), INPUT-OUTPUT object-type, INPUT-OUTPUT cTempFile) NO-ERROR.
    IF ERROR-STATUS:ERROR THEN RETURN error-status:get-message(1).
  END.
  ELSE cTempFile = cFile.
  COMPILE VALUE(cTempFile) SAVE NO-ERROR.
  IF ERROR-STATUS:ERROR
  THEN DO i1 = 1 TO ERROR-STATUS:NUM-MESSAGES:
    cReturn = (IF cReturn > "" THEN "<br>" ELSE "") + error-status:get-message(i1).
  END.
  ELSE cReturn = "OK".

  IF cTempFile > "" AND cTempFile <> cFile
  THEN OS-DELETE VALUE(cTempFile) NO-ERROR.

  RETURN cReturn.
END FUNCTION.









procedure pAdd:
  input  stream sIn from value(search("webtools/webtools.dat")).
  repeat:
    assign cIn = "".
    import stream sIn unformatted cIn.
    assign cdata = cData + cIn + chr(10).
  end.
  input  stream sIn close.

  if not (cData matches "*plus/db*" and cData matches "*plus/am*") then do:
   assign
    iPos = index(cData,'<B><FONT SIZE = "+1">Session:</FONT></B><br>')
    iPos = if iPos < 10
           then index(cData,"<br>") + 5
           else r-index(substring(cData,1,iPos - 7),"<br>") + 5.
    substring(cData,iPos,0) = chr(10) +
      '<A HREF="../plus/am">App. Manager</A><br> ' + chr(10) +
      '<A HREF="../plus/db">Data Browser</A><br> ' + chr(10).
  end.
  output stream sIn to value(search("webtools/webtools.dat")).
  put    stream sIn unformatted cdata skip.
  output stream sIn close.
end procedure.

procedure pRemove:
  input  stream sIn from value(search("webtools/webtools.dat")).
  repeat:
    assign cIn = "".
    import stream sIn unformatted cIn.
    if cIn matches '*plus/appman*' OR
       cIn matches '*plus/databr*' THEN NEXT.
    assign cdata = cData + cIn + chr(10).
  end.
  input  stream sIn close.
  output stream sIn to value(search("webtools/webtools.dat")).
  put    stream sIn unformatted cdata skip.
  output stream sIn close.
end procedure.

procedure pTest:
  input  stream sIn from value(search("webtools/webtools.dat")).
  repeat:
    import stream sIn unformatted cIn.
    if cIn matches '*plus/databr*' OR
       cIn matches '*plus/appman*' THEN RETURN "OK".
  end.
  input  stream sIn close.
  return "NO".
end procedure.


/**** Output header section  *****/


{&cNo-Cache}
output-content-type("text/html").

if selfurl matches "*webtools/edtscrpt.*" then do:
  {&out} "
    <script language=javascript>
    window.open('../plus/setup.p','_self');
    </script>" skip.

  STOP.
end.

ASSIGN
  cDest = IF GET-value("from") > ""
          THEN REPLACE(SEARCH("workshop.r"),"workshop.r","")
          ELSE GET-value("cdest").
IF cDest = "" THEN cDest = REPLACE(SEARCH("workshop.r"),"workshop.r","").





{&OUT} '<HTML><HEAD><TITLE>WS-PlusPack</TITLE></HEAD>~n'.
{&OUT} '<BODY BACKGROUND="' get-config('wsRoot') '/images/bgr/wsbgr.gif" BGCOLOR="#FFFFCC" TEXT="#990000" LINK="#660066" VLINK="#990000" ALINK="#990000">~n'.
{&OUT} '<TABLE BORDER=0 WIDTH="100%"><TR>~n'.
{&OUT} '<TD ALIGN="LEFT">~n'.
{&OUT} '<IMG SRC="' get-config('wsRoot') '/images/l-tools.gif" BORDER=0 ALIGN="CENTER"> <FONT SIZE="+2" COLOR="#660066"><B>WS-PlusPack Setup</b></FONT></TD>~n'.
{&OUT} '<TD ALIGN= "RIGHT">&nbsp;</TD>~n'.
{&OUT} '</TR></TABLE>~n'.

{&OUT} '<CENTER><IMG SRC="' get-config('wsRoot') '/images/wsrule.gif" HEIGHT=3 WIDTH="100%"></CENTER><CENTER>~n'.
{&OUT} '<FORM METHOD="POST" ACTION="' selfurl '">~n'.
{&OUT} '   <input type="submit" name="refresh" value="Refresh">~n'.


  IF GET-VALUE("compile") > "" THEN DO:
    ASSIGN cDB = substring(cDest,1,INDEX(cDest,"tty") - 1) NO-ERROR.
    IF ERROR-STATUS:ERROR
    THEN {&out} "<br>Cannot find your 'tty' directory." SKIP.
    ELSE DO:
      create database "plus/empty".
      connect -1 -ldb plus -db plus/empty.db.
      {&out} '<br>creating and connecting "' cDest + 'plus/empty.db" for compile, ' string(connected("empty"),"OK/Cannot connect") "<br>" SKIP.
    END.
    INPUT FROM OS-DIR(cDest + "plus").
    REPEAT:
      IMPORT cIn.
      IF cIn MATCHES "*.r" and cIn <> "vst.r"  /*** Sending ready compiled version of the VST program for WS2.1 ***/
      THEN DO:
        OS-DELETE VALUE(cDest + "plus/" + cIn).
      END.
    END.
    INPUT CLOSE.

    INPUT FROM OS-DIR(cDest + "plus").
    REPEAT:
      IMPORT cIn.
      IF cIn MATCHES "*.p" OR
         cIn MATCHES "*.w" OR
         cIn MATCHES "*.htm" OR
         cIn MATCHES "*.html"
      THEN DO:
        fCompile(cDest + "plus/" + cIn).
      END.
    END.
    INPUT CLOSE.




    disconnect "empty".
  END.
  IF GET-VALUE("add") > "" THEN DO:
    RUN pAdd.
  END.
  IF GET-VALUE("remove") > "" THEN DO:
    RUN pRemove.
  END.
  IF GET-VALUE("delete") > "" THEN DO:
    OS-DELETE VALUE(cDest + "plus") RECURSIVE.
  END.
  IF GET-VALUE("backup") > "" THEN DO:
    OS-COPY VALUE(cDest + "webtools/webtools.dat") VALUE(cDest + "webtools/webtoolsdat.old").
  END.
  IF GET-VALUE("restore") > "" THEN DO:
    OS-COPY VALUE(cDest + "webtools/webtoolsdat.old") VALUE(cDest + "webtools/webtools.dat").
  END.
  IF GET-VALUE("restore") + GET-VALUE("remove") + GET-VALUE("add") > ""
  THEN {&out} "
      <script language=javascript>
      window.open('../webtools/index.w','WS_index');
      </script>" skip.


  RUN pTest.
  ASSIGN
    cStat1 = IF SEARCH(cDest + "plus/appman.html") > ""
             THEN "OK"
             ELSE "Not installed"
    cStat2 = IF SEARCH(cDest + "plus/vst.r") > ""  AND SEARCH(cDest + "plus/listtables.r") > ""
             THEN "OK"
        ELSE IF SEARCH(cDest + "plus/listtables.r") > ""
             THEN "VST not able to compile, otherwise OK."
        ELSE IF SEARCH(cDest + "plus/appman.r") > ""
             THEN "Need database to compile certain files."
             ELSE "Need to compile."
    cStat3 = IF RETURN-value = "OK"
             THEN "OK"
             ELSE "Not installed".


{&OUT} '<TABLE BORDER="1" CELLPADDING="0" CELLSPACING="1" width="100%">~n'.
{&OUT} ' <tr> ~n'.
{&OUT} '  <td> ~n'.
{&OUT} '   <big>Install Step1: Copy the program files.</big><br>~n'.
{&OUT} '   Copy the files to a new tty/plus directory.<br>~n'.
{&OUT} '   <font color=red><b>'  cStat1  '</b></font> ~n'.
{&OUT} '  </td>~n'.
{&OUT} '  <td> &nbsp; ~n'.
{&OUT} '  </td>~n'.
{&OUT} ' </tr>~n'.

{&OUT} ' <tr> ~n'.
{&OUT} '  <td> ~n'.
{&OUT} '   <big>Install Step2: Compile the programs.</big><br>~n'.
{&OUT} '   It compiles the code at the destination path (+plus).~n'.
{&OUT} '   To be able to compile the code this program creates and connects plus/empty.db.~n'.
{&OUT}  if not proversion begins "9" THEN "Your empty.db cannot connect with VST in sungle-user mode, but is necessary for the VST program to compile.
    You might have to compile that file later." ELSE ""  .
{&OUT} '   <br><font color=red><b>'  cStat2  '</b></font> ~n'.
{&OUT} '  </td>~n'.
{&OUT} '  <td> ~n'.
{&OUT} '   <input type="submit" name="compile" value="Compile the programs">~n'.
{&OUT} '  </td>~n'.
{&OUT} ' </tr>~n'.

{&OUT} ' <tr> ~n'.
{&OUT} '  <td> ~n'.
{&OUT} '   <big>Install Step3: Modify webtools menu.</big><br>~n'.
{&OUT} '   Modify the ''webtools.dat'' file to contain entries for Appman and DataBrowser. ~n'.
{&OUT} '   Please first backup the original webtools.dat by pressing the backup button. ~n'.
{&OUT} '   It will create a webtoolsdat.old file in the same directory. ~n'.
{&OUT} '   <br><font color=red><b>'  cStat3  '</b></font> ~n'.
{&OUT} '  </td>~n'.
{&OUT} '  <td> ~n'.
{&OUT} '   <input type=submit name=backup value="Backup webtools.dat"><br>~n'.
{&OUT} '   <input type=submit name=add    value="Add to webtools menu">~n'.
{&OUT} '  </td>~n'.
{&OUT} ' </tr>~n'.

{&OUT} ' <tr> ~n'.
{&OUT} '  <td> ~n'.
{&OUT} '   <big>Finished: Configure the Application Manager.</big>~n'.
{&OUT} '<br>1. Appman --> Servers: Click Config, Add the servers you want to administer.~n'.
{&OUT} '<br>2. Appman --> DB-Util, Go to the respective databases util menu and check that the -pf is correctly set.~n'.
{&OUT} '<br>3. Appman --> Add application code paths you want to administer. ~n'.
{&OUT} '<br>4. Enjoy ....~n'.
{&OUT} '  </td>~n'.
{&OUT} '  <td> ~n'.
{&OUT} '  &nbsp;</td>~n'.
{&OUT} ' </tr>~n'.

{&OUT} ' <tr> ~n'.
{&OUT} '  <td> ~n'.
{&OUT} '   <big>Uninstall Step1: Restore webtools menu.</big><br>~n'.
{&OUT} '   Restore old ''webtools.dat'' file. ~n'.
{&OUT} '  </td>~n'.
{&OUT} '  <td> ~n'.
{&OUT} '   <input type=submit name=remove  value="Remove from webtools menu">~n'.
{&OUT} '   <input type=submit name=restore value="Restore webtoolsdat.old">~n'.
{&OUT} '  </td>~n'.
{&OUT} ' </tr>~n'.

{&OUT} ' <tr> ~n'.
{&OUT} '  <td> ~n'.
{&OUT} '   <big>Uninstall Step2: Delete program files.</big><br>~n'.
{&OUT} '   Remove Appman and DataBrowser program files from the ''tty/plus'' directory. ~n'.
{&OUT} '   This will delete the plus directory from $DLC/tty.~n'.
{&OUT} '  </td>~n'.
{&OUT} '  <td> ~n'.
{&OUT} '   <input type=submit name=delete value="Delete program files">~n'.
{&OUT} '  </td>~n'.
{&OUT} ' </tr>~n'.
{&OUT} '</TABLE>~n'.
{&OUT} '</FORM>~n'.
{&OUT} '</CENTER>~n'.
{&OUT} '</BODY>~n'.
{&OUT} '</HTML>~n'.

